/*
 * AOChat -- library for talking with the Anarchy Online chat servers
 * Copyright (C) 2002  Oskari Saarenmaa <pickett@sumu.org>
 *
 * $Id: misc.c,v 1.1 2002/11/14 09:53:35 pickett Exp $
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307
 * USA
 *
 */
 
/*
 * miscellanous functions, not directly related to anarchy online
 *
 */

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#include "misc.h"

static inline void p_seed_random();

static inline void
p_seed_random()
{
  FILE *ur;
  char crnd[4];
  unsigned long rnd;
  static char seeded;
  
  if(seeded)
    return;
  
  seeded = 1;
  ur = fopen("/dev/urandom", "r");
  read(fileno(ur), crnd, 4);
  fclose(ur);
  rnd = *((unsigned long*)crnd);
  srand(rnd);
}

int
p_random(int n)
{
  p_seed_random();
  return (int)((n*1.0)*rand()/(RAND_MAX+1.0));
}

int
htoi(int c)
{
  if(c >= '0' && c <= '9') return c-48;
  if(c >= 'A' && c <= 'F') return c-55;
  if(c >= 'a' && c <= 'f') return c-87;
  return 0;
}

int
hexdec(char *x, short bytes)
{
  int p, q, r = 0;

  if(bytes == 0)
    bytes = strlen(x);
    
  for(p = q = bytes - 1; p >= 0; p--)
    r += htoi(x[p]) * 1<<(4*(q-p));
  
  return r;
}
